#version 100

precision highp float;
//precision mediump float;

attribute vec3 aVertexPosition;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

uniform vec2 flameFlags;

varying float depth;
varying float spd;

void main(void) {
	mat4 mv = viewMatrix * modelMatrix;
	vec4 vertexPosition = vec4(aVertexPosition,1.0);
	
	float s = sin(vertexPosition.z + flameFlags[1]);
	vertexPosition.y += vertexPosition.y * s*vertexPosition.z*0.2;
	vertexPosition.x += vertexPosition.x * s*vertexPosition.z*0.2;
	depth = vertexPosition.z/2.0;
	spd = flameFlags[0];
	gl_Position = projectionMatrix * mv * vertexPosition;
}
