#version 100

precision highp float;
//precision mediump float;

const vec3 BRIGHT_COLOR = vec3(0.9,0.9,0.9);

attribute vec3 aVertexPosition;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
uniform vec4 flags;
uniform vec3 skyFlags_sunPos;
uniform vec3 skyFlags_color1;
uniform vec3 skyFlags_color2;
uniform vec3 skyFlags_color3;

const float PI = 3.14159265;

varying vec4 vColor;

void main(void) {
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(aVertexPosition,1.0);
	
	float dayAmmount = flags[1];
	float skyHeight = flags[2];
	float x = aVertexPosition[1]/skyHeight;
	vec3 color1=vec3(0,0,0), color2=vec3(0,0,0);
		
	float v = 0.0;
	if(x >= 0.5)
	{
		v = 1.0-(x-0.5)*2.0;
		color1 = skyFlags_color1;
		color2 = skyFlags_color2;
	}
	if(x > 0.25 && x <= 0.5)
	{
		v = 1.0-(x-0.25)*4.0;
		color1 = skyFlags_color2;
		color2 = skyFlags_color3;
	}
	if(x <= 0.25)
	{
		v = 1.0-x*4.0;
		float f = max(dayAmmount,1.0)*2.0-3.0;
		v *= f*f*f*f;
		color1 = skyFlags_color3;
		color2 = BRIGHT_COLOR;
	}
	vec3 color = mix(color1, color2, v);

	float radius = skyHeight/2.0;
	float d = min(distance(skyFlags_sunPos, (modelMatrix * vec4(aVertexPosition,0)).xyz),radius);
	float magnitude = (radius - d)/radius;
	color = mix(color, BRIGHT_COLOR, magnitude);
	if(x <= 0.25)
		color = mix(color, vec3(1,0.61,0.33), v*magnitude*pow(abs(cos(dayAmmount*PI)),10.0));

	vColor = vec4(color, 1.0);
}
